package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="装船指令从表")
public class OmsshipInstructionsCapacity implements IBasePO<BigDecimal> {
    /**
     * 主键ID(INSTRUCTIONS_CAPACITY_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal instructionsCapacityId;

    /**
     * 装船指令ID(INSTRUCTIONS_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="装船指令ID",required=false)
    private BigDecimal instructionsId;

    /**
     * 运力ID(CAPACITY_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="运力ID",required=false)
    private BigDecimal capacityId;

    /**
     * 计划装载吨位(INSTRUCTION_PLANNED_LOADING,DECIMAL,0)
     */
    @ApiModelProperty(value="计划装载吨位",required=false)
    private BigDecimal instructionPlannedLoading;

    /**
     * 船舶当前位置(INSTRUCTIONS_SHIP_POSITION,VARCHAR,20)
     */
    @ApiModelProperty(value="船舶当前位置",required=false)
    private String instructionsShipPosition;

    /**
     * 船舶联系方式(INSTRUCTION_CONTACT_INF,VARCHAR,50)
     */
    @ApiModelProperty(value="船舶联系方式",required=false)
    private String instructionContactInf;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 船舶状态(INSTRUCTIONS_CAPACITY_STATUS,VARCHAR,100)
     */
    @ApiModelProperty(value="船舶状态",required=false)
    private String instructionsCapacityStatus;

    /**
     * 逻辑删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除",required=false)
    private BigDecimal deleted;

    /**
     * 预计到港时间(INSTRUCTION_ESARRIVAL_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="预计到港时间",required=false)
    private Date instructionEsarrivalTime;

    /**
     * 船舶动态(SHIP_DYNAMIC,VARCHAR,100)
     */
    @ApiModelProperty(value="船舶动态",required=false)
    private String shipDynamic;

    /**
     * 装船详情(LOAD_DETAILS,VARCHAR,100)
     */
    @ApiModelProperty(value="装船详情",required=false)
    private String loadDetails;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.instructionsCapacityId;
    }

    @Override
    public void setId(BigDecimal instructionsCapacityId) {
        this.instructionsCapacityId = instructionsCapacityId;
    }

    public BigDecimal getInstructionsCapacityId() {
        return instructionsCapacityId;
    }

    public void setInstructionsCapacityId(BigDecimal instructionsCapacityId) {
        this.instructionsCapacityId = instructionsCapacityId;
    }

    public BigDecimal getInstructionsId() {
        return instructionsId;
    }

    public void setInstructionsId(BigDecimal instructionsId) {
        this.instructionsId = instructionsId;
    }

    public BigDecimal getCapacityId() {
        return capacityId;
    }

    public void setCapacityId(BigDecimal capacityId) {
        this.capacityId = capacityId;
    }

    public BigDecimal getInstructionPlannedLoading() {
        return instructionPlannedLoading;
    }

    public void setInstructionPlannedLoading(BigDecimal instructionPlannedLoading) {
        this.instructionPlannedLoading = instructionPlannedLoading;
    }

    public String getInstructionsShipPosition() {
        return instructionsShipPosition;
    }

    public void setInstructionsShipPosition(String instructionsShipPosition) {
        this.instructionsShipPosition = instructionsShipPosition == null ? null : instructionsShipPosition.trim();
    }

    public String getInstructionContactInf() {
        return instructionContactInf;
    }

    public void setInstructionContactInf(String instructionContactInf) {
        this.instructionContactInf = instructionContactInf == null ? null : instructionContactInf.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public String getInstructionsCapacityStatus() {
        return instructionsCapacityStatus;
    }

    public void setInstructionsCapacityStatus(String instructionsCapacityStatus) {
        this.instructionsCapacityStatus = instructionsCapacityStatus == null ? null : instructionsCapacityStatus.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public Date getInstructionEsarrivalTime() {
        return instructionEsarrivalTime;
    }

    public void setInstructionEsarrivalTime(Date instructionEsarrivalTime) {
        this.instructionEsarrivalTime = instructionEsarrivalTime;
    }

    public String getShipDynamic() {
        return shipDynamic;
    }

    public void setShipDynamic(String shipDynamic) {
        this.shipDynamic = shipDynamic == null ? null : shipDynamic.trim();
    }

    public String getLoadDetails() {
        return loadDetails;
    }

    public void setLoadDetails(String loadDetails) {
        this.loadDetails = loadDetails == null ? null : loadDetails.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", instructionsCapacityId=").append(instructionsCapacityId);
        sb.append(", instructionsId=").append(instructionsId);
        sb.append(", capacityId=").append(capacityId);
        sb.append(", instructionPlannedLoading=").append(instructionPlannedLoading);
        sb.append(", instructionsShipPosition=").append(instructionsShipPosition);
        sb.append(", instructionContactInf=").append(instructionContactInf);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", instructionsCapacityStatus=").append(instructionsCapacityStatus);
        sb.append(", deleted=").append(deleted);
        sb.append(", instructionEsarrivalTime=").append(instructionEsarrivalTime);
        sb.append(", shipDynamic=").append(shipDynamic);
        sb.append(", loadDetails=").append(loadDetails);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}