package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="水分质检结果")
public class TmsshipWaterQualityResult implements IBasePO<BigDecimal> {
    /**
     * 主键ID(RESULT_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal resultId;

    /**
     * 总实绩ID(TOTAL_RESULT_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="总实绩ID",required=false)
    private BigDecimal totalResultId;

    /**
     * 计划日期(RESULT_PLANNED_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="计划日期",required=false)
    private Date resultPlannedDate;

    /**
     * 货权日期(RESULT_CARGO_RIGHTS_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="货权日期",required=false)
    private Date resultCargoRightsDate;

    /**
     * 装船比例（该船实装吨位/整个装船指令下实装总吨位）(RESULT_SHIPMENT_RATIO,DECIMAL,0)
     */
    @ApiModelProperty(value="装船比例（该船实装吨位/整个装船指令下实装总吨位）",required=false)
    private BigDecimal resultShipmentRatio;

    /**
     * 空舱/重载水尺米(RESULT_EMPTY_HEAVY_WATER_METER,VARCHAR,20)
     */
    @ApiModelProperty(value="空舱/重载水尺米",required=false)
    private String resultEmptyHeavyWaterMeter;

    /**
     * 含水率(RESULT_MOISTURE_CONTENT,DECIMAL,0)
     */
    @ApiModelProperty(value="含水率",required=false)
    private BigDecimal resultMoistureContent;

    /**
     * 水分吨位(RESULT_WATER_TONNAGE,DECIMAL,0)
     */
    @ApiModelProperty(value="水分吨位",required=false)
    private BigDecimal resultWaterTonnage;

    /**
     * 检测费(RESULT_INSPECTION_FEES,DECIMAL,0)
     */
    @ApiModelProperty(value="检测费",required=false)
    private BigDecimal resultInspectionFees;

    /**
     * 废除人(DELETE_NAME,VARCHAR,16)
     */
    @ApiModelProperty(value="废除人",required=false)
    private String deleteName;

    /**
     * 废除时间(DELETE_TIME,VARCHAR,14)
     */
    @ApiModelProperty(value="废除时间",required=false)
    private String deleteTime;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 预计放货日期(RESULT_ES_DELIVERY_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="预计放货日期",required=false)
    private Date resultEsDeliveryDate;

    /**
     * 逻辑删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除",required=false)
    private BigDecimal deleted;

    /**
     * 水运单价(WATER_UNIT_PRICE,DECIMAL,0)
     */
    @ApiModelProperty(value="水运单价",required=false)
    private BigDecimal waterUnitPrice;

    /**
     * 是否需要拼装(IS_NEED_ASSEMBLE,VARCHAR,20)
     */
    @ApiModelProperty(value="是否需要拼装",required=false)
    private String isNeedAssemble;

    /**
     * 水运单价ID(UNIT_PRICE_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="水运单价ID",required=false)
    private BigDecimal unitPriceId;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.resultId;
    }

    @Override
    public void setId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getResultId() {
        return resultId;
    }

    public void setResultId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getTotalResultId() {
        return totalResultId;
    }

    public void setTotalResultId(BigDecimal totalResultId) {
        this.totalResultId = totalResultId;
    }

    public Date getResultPlannedDate() {
        return resultPlannedDate;
    }

    public void setResultPlannedDate(Date resultPlannedDate) {
        this.resultPlannedDate = resultPlannedDate;
    }

    public Date getResultCargoRightsDate() {
        return resultCargoRightsDate;
    }

    public void setResultCargoRightsDate(Date resultCargoRightsDate) {
        this.resultCargoRightsDate = resultCargoRightsDate;
    }

    public BigDecimal getResultShipmentRatio() {
        return resultShipmentRatio;
    }

    public void setResultShipmentRatio(BigDecimal resultShipmentRatio) {
        this.resultShipmentRatio = resultShipmentRatio;
    }

    public String getResultEmptyHeavyWaterMeter() {
        return resultEmptyHeavyWaterMeter;
    }

    public void setResultEmptyHeavyWaterMeter(String resultEmptyHeavyWaterMeter) {
        this.resultEmptyHeavyWaterMeter = resultEmptyHeavyWaterMeter == null ? null : resultEmptyHeavyWaterMeter.trim();
    }

    public BigDecimal getResultMoistureContent() {
        return resultMoistureContent;
    }

    public void setResultMoistureContent(BigDecimal resultMoistureContent) {
        this.resultMoistureContent = resultMoistureContent;
    }

    public BigDecimal getResultWaterTonnage() {
        return resultWaterTonnage;
    }

    public void setResultWaterTonnage(BigDecimal resultWaterTonnage) {
        this.resultWaterTonnage = resultWaterTonnage;
    }

    public BigDecimal getResultInspectionFees() {
        return resultInspectionFees;
    }

    public void setResultInspectionFees(BigDecimal resultInspectionFees) {
        this.resultInspectionFees = resultInspectionFees;
    }

    public String getDeleteName() {
        return deleteName;
    }

    public void setDeleteName(String deleteName) {
        this.deleteName = deleteName == null ? null : deleteName.trim();
    }

    public String getDeleteTime() {
        return deleteTime;
    }

    public void setDeleteTime(String deleteTime) {
        this.deleteTime = deleteTime == null ? null : deleteTime.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public Date getResultEsDeliveryDate() {
        return resultEsDeliveryDate;
    }

    public void setResultEsDeliveryDate(Date resultEsDeliveryDate) {
        this.resultEsDeliveryDate = resultEsDeliveryDate;
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public BigDecimal getWaterUnitPrice() {
        return waterUnitPrice;
    }

    public void setWaterUnitPrice(BigDecimal waterUnitPrice) {
        this.waterUnitPrice = waterUnitPrice;
    }

    public String getIsNeedAssemble() {
        return isNeedAssemble;
    }

    public void setIsNeedAssemble(String isNeedAssemble) {
        this.isNeedAssemble = isNeedAssemble == null ? null : isNeedAssemble.trim();
    }

    public BigDecimal getUnitPriceId() {
        return unitPriceId;
    }

    public void setUnitPriceId(BigDecimal unitPriceId) {
        this.unitPriceId = unitPriceId;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", resultId=").append(resultId);
        sb.append(", totalResultId=").append(totalResultId);
        sb.append(", resultPlannedDate=").append(resultPlannedDate);
        sb.append(", resultCargoRightsDate=").append(resultCargoRightsDate);
        sb.append(", resultShipmentRatio=").append(resultShipmentRatio);
        sb.append(", resultEmptyHeavyWaterMeter=").append(resultEmptyHeavyWaterMeter);
        sb.append(", resultMoistureContent=").append(resultMoistureContent);
        sb.append(", resultWaterTonnage=").append(resultWaterTonnage);
        sb.append(", resultInspectionFees=").append(resultInspectionFees);
        sb.append(", deleteName=").append(deleteName);
        sb.append(", deleteTime=").append(deleteTime);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", resultEsDeliveryDate=").append(resultEsDeliveryDate);
        sb.append(", deleted=").append(deleted);
        sb.append(", waterUnitPrice=").append(waterUnitPrice);
        sb.append(", isNeedAssemble=").append(isNeedAssemble);
        sb.append(", unitPriceId=").append(unitPriceId);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}