package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="万州港火运批复表")
public class TmstrainPleaseResult implements IBasePO<BigDecimal> {
    /**
     * 主键ID(RESULT_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal resultId;

    /**
     * 采购订单id(RAIL_PLAN_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="采购订单id",required=false)
    private BigDecimal railPlanId;

    /**
     * 请车计划号(RESULT_PLEASE_PLAN_NO,VARCHAR,50)
     */
    @ApiModelProperty(value="请车计划号",required=false)
    private String resultPleasePlanNo;

    /**
     * 日期(RESULT_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="日期",required=false)
    private Date resultDate;

    /**
     * 批复车数(RESULT_APPROVE_NUMBER,DECIMAL,0)
     */
    @ApiModelProperty(value="批复车数",required=false)
    private BigDecimal resultApproveNumber;

    /**
     * 落空车数(RESULT_VOID_NUMBER,DECIMAL,0)
     */
    @ApiModelProperty(value="落空车数",required=false)
    private BigDecimal resultVoidNumber;

    /**
     * 实际车数(RESULT_REAL_NUMBER,DECIMAL,0)
     */
    @ApiModelProperty(value="实际车数",required=false)
    private BigDecimal resultRealNumber;

    /**
     * 剩余车数(RESULT_SURPLUS_NUMBER,DECIMAL,0)
     */
    @ApiModelProperty(value="剩余车数",required=false)
    private BigDecimal resultSurplusNumber;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 逻辑删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除",required=false)
    private BigDecimal deleted;

    /**
     * 请车批车类型：1：采购进口矿（万州港-达州站/万州港-老区轨道衡）3：采购国产矿  4：内转钢材到异地库(RESULT_TYPE,DECIMAL,0)
     */
    @ApiModelProperty(value="请车批车类型：1：采购进口矿（万州港-达州站/万州港-老区轨道衡）3：采购国产矿  4：内转钢材到异地库",required=false)
    private BigDecimal resultType;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.resultId;
    }

    @Override
    public void setId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getResultId() {
        return resultId;
    }

    public void setResultId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getRailPlanId() {
        return railPlanId;
    }

    public void setRailPlanId(BigDecimal railPlanId) {
        this.railPlanId = railPlanId;
    }

    public String getResultPleasePlanNo() {
        return resultPleasePlanNo;
    }

    public void setResultPleasePlanNo(String resultPleasePlanNo) {
        this.resultPleasePlanNo = resultPleasePlanNo == null ? null : resultPleasePlanNo.trim();
    }

    public Date getResultDate() {
        return resultDate;
    }

    public void setResultDate(Date resultDate) {
        this.resultDate = resultDate;
    }

    public BigDecimal getResultApproveNumber() {
        return resultApproveNumber;
    }

    public void setResultApproveNumber(BigDecimal resultApproveNumber) {
        this.resultApproveNumber = resultApproveNumber;
    }

    public BigDecimal getResultVoidNumber() {
        return resultVoidNumber;
    }

    public void setResultVoidNumber(BigDecimal resultVoidNumber) {
        this.resultVoidNumber = resultVoidNumber;
    }

    public BigDecimal getResultRealNumber() {
        return resultRealNumber;
    }

    public void setResultRealNumber(BigDecimal resultRealNumber) {
        this.resultRealNumber = resultRealNumber;
    }

    public BigDecimal getResultSurplusNumber() {
        return resultSurplusNumber;
    }

    public void setResultSurplusNumber(BigDecimal resultSurplusNumber) {
        this.resultSurplusNumber = resultSurplusNumber;
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public BigDecimal getResultType() {
        return resultType;
    }

    public void setResultType(BigDecimal resultType) {
        this.resultType = resultType;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", resultId=").append(resultId);
        sb.append(", railPlanId=").append(railPlanId);
        sb.append(", resultPleasePlanNo=").append(resultPleasePlanNo);
        sb.append(", resultDate=").append(resultDate);
        sb.append(", resultApproveNumber=").append(resultApproveNumber);
        sb.append(", resultVoidNumber=").append(resultVoidNumber);
        sb.append(", resultRealNumber=").append(resultRealNumber);
        sb.append(", resultSurplusNumber=").append(resultSurplusNumber);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", resultType=").append(resultType);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}