package com.steerinfo.dil.service;

import com.steerinfo.dil.model.TmsshipLoadShipResult;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * TmsshipLoadShipResult服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 08:47
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmsshipLoadShipResult服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface ITmsshipLoadShipResultService {

    /**
     * 插入装船
     * @param map
     * @return
     */
    int insertLoadShip(Map<String,Object> map) throws Exception;

    /**
     * 根据主键删除
     * @param resultId
     * @return
     */
    int deleteLoadShip(BigDecimal resultId);


    /**
     * 根据主键查看详细
     * @param resultId
     * @return
     */
    TmsshipLoadShipResult selectLoadShip(BigDecimal resultId);


    /**
     * 根据主键修改
     * @param map
     * @return
     */
    int updateLoadShip(Map<String,Object> map);

    int updateThreeSectionDetails(Map<String,Object> map);

    /**
     * 查询所有作业位置
     * @return
     */
    List<Map<String,Object>> selectLoadShipList(Map<String,Object> mapVal);

    /**
     * 查询总重量
     * @param instructionsId
     * @return
     */
    BigDecimal selectAllWeight(BigDecimal instructionsId);

    /**
     * 查询装船表单
     * @return
     */
    List<Map<String,Object>> getLoadShip(BigDecimal resultId);

    /**
     * 根据外轮船名和物资名称得到批次id
     * @param mapVal
     * @return
     */
    BigDecimal getBatchId(Map<String,Object> mapVal);

}