package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.OmsshipInstructionsCapacityMapper;
import com.steerinfo.dil.mapper.RmsCapacityMapper;
import com.steerinfo.dil.model.OmsshipInstructionsCapacity;
import com.steerinfo.dil.model.RmsCapacity;
import com.steerinfo.dil.service.IOmsshipInstructionsCapacityService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * OmsshipInstructionsCapacity服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-20 03:06
 * 类描述
 * 修订历史：
 * 日期：2021-08-20
 * 作者：generator
 * 参考：
 * 描述：OmsshipInstructionsCapacity服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "omsshipInstructionsCapacityService")
public class OmsshipInstructionsCapacityServiceImpl implements IOmsshipInstructionsCapacityService {

    @Autowired
    OmsshipInstructionsCapacityMapper omsshipInstructionsCapacityMapper;

    @Autowired
    RmsCapacityMapper rmsCapacityMapper;


    @Override
    public List<Map<String, Object>> getOrderId() {
        return omsshipInstructionsCapacityMapper.selectOrderId();
    }

    /**
     * 获得最大id
     * @return
     */
    @Override
    public BigDecimal selectMaxId() {
        return omsshipInstructionsCapacityMapper.selectMaxId();
    }

    /**
     * 新增
     * @param omsshipInstructionsCapacity
     * @return
     */
    @Transactional
    @Override
    public int insert(Map<String,Object> omsshipInstructionsCapacity) {
        //插入装船指令
        OmsshipInstructionsCapacity realOmsshipInstructionsCapacity = new OmsshipInstructionsCapacity();
        String omsship= ""+omsshipInstructionsCapacity.get("capacityIds");
       //判断是否有id值传入，有则代表表中含有这个船名
        if (!"".equals(omsship)){
            Integer capacityNumber = (Integer) omsshipInstructionsCapacity.get("capacityIds");
            realOmsshipInstructionsCapacity.setCapacityId(new BigDecimal(capacityNumber));
        }else{
           //判断用户输入的船名在数据库中是否存在
            String capacityNumber=(String)omsshipInstructionsCapacity.get("capacityName");
           //查询运力表中是否含有对应的运力编号
            BigDecimal capacityId=null;
            BigDecimal bookingNumber=null;
            List<Map<String,Object>> mapList = rmsCapacityMapper.getCapacityIdByCapacityNumber(capacityNumber);
            if (mapList!=null && mapList.size() != 0) {
              capacityId = DataChange.dataToBigDecimal(mapList.get(0).get("capacityId"));
              bookingNumber =DataChange.dataToBigDecimal(mapList.get(0).get("bookingNumber"));
            }
            BigDecimal capacityBookingNumber = DataChange.dataToBigDecimal(omsshipInstructionsCapacity.get("capacityBookingNumber"));
            if (capacityId != null) {
               //当运力编号存在的时候，将获取到的运力编号的id插入进去
                realOmsshipInstructionsCapacity.setCapacityId(capacityId);
                //根据对应的航次和传输的航次做对比
                if (!bookingNumber.equals(capacityBookingNumber)) {
                   RmsCapacity rmsCapacity=new RmsCapacity();
                   rmsCapacity.setCapacityId(capacityId);
                   rmsCapacity.setCapacityBookingNumber(capacityBookingNumber);
                   rmsCapacityMapper.updateByPrimaryKeySelective(rmsCapacity);
                }
            }
            else {
              //当运力编号不存在的时候，在运力表中新增一条运力信息，并将运力类型设置为3，也就是船类型
                RmsCapacity rmsCapacity = new RmsCapacity();
                rmsCapacity.setCapacityId(rmsCapacityMapper.selectCapacityId());
                rmsCapacity.setCapacityNumber(capacityNumber);
                rmsCapacity.setCapacityTypeId(new BigDecimal(3));
                rmsCapacity.setDeleted(new BigDecimal(0));
                rmsCapacity.setCapacityTel((String)omsshipInstructionsCapacity.get("instructionContactInf"));
                if (capacityBookingNumber!=null) {
                    rmsCapacity.setCapacityBookingNumber(capacityBookingNumber);
                }
                rmsCapacityMapper.insertSelective(rmsCapacity);
                realOmsshipInstructionsCapacity.setCapacityId(rmsCapacity.getCapacityId());
            }
        }
        String instructionPlannedLoading = (String) omsshipInstructionsCapacity.get("instructionPlannedLoading");
        String instructionsShipPosition = (String) omsshipInstructionsCapacity.get("instructionsShipPosition");
        String instructionContactInf = (String) omsshipInstructionsCapacity.get("instructionContactInf");
        String instructionsCapacityStatus = (String) omsshipInstructionsCapacity.get("instructionsCapacityStatus");
        Date instructionEsarrivalTime = new Date((Long) omsshipInstructionsCapacity.get("instructionEsarrivalTime"));
        BigDecimal instructionsId = new BigDecimal((String) omsshipInstructionsCapacity.get("instructionsId"));
        realOmsshipInstructionsCapacity.setInstructionsId(instructionsId);
        realOmsshipInstructionsCapacity.setInstructionContactInf(instructionContactInf);
        realOmsshipInstructionsCapacity.setInstructionEsarrivalTime(instructionEsarrivalTime);
        realOmsshipInstructionsCapacity.setInstructionsCapacityStatus(instructionsCapacityStatus);
        realOmsshipInstructionsCapacity.setInstructionsShipPosition(instructionsShipPosition);
        realOmsshipInstructionsCapacity.setInstructionPlannedLoading(new BigDecimal(instructionPlannedLoading));
        realOmsshipInstructionsCapacity.setInstructionsCapacityId(omsshipInstructionsCapacityMapper.selectInstructionCapacityId());
        // 设置常规字段
        realOmsshipInstructionsCapacity.setDeleted(new BigDecimal(0));
        realOmsshipInstructionsCapacity.setInsertTime(new Date());
        realOmsshipInstructionsCapacity.setInsertUsername("admin");
        realOmsshipInstructionsCapacity.setInsertUpdateRemark("无");
        realOmsshipInstructionsCapacity.setUpdateTime(new Date());
        realOmsshipInstructionsCapacity.setUpdateUsername("admin");
        return omsshipInstructionsCapacityMapper.insert(realOmsshipInstructionsCapacity);
    }

    /**
     * 逻辑删除
     * @param instructionsCapacityId
     * @return
     */
    @Override
    public int deleteByPrimaryKey(BigDecimal instructionsCapacityId) {
        OmsshipInstructionsCapacity omsshipInstructionsCapacity = selectByPrimaryKey(instructionsCapacityId);
        omsshipInstructionsCapacity.setDeleted(new BigDecimal(1));
        return omsshipInstructionsCapacityMapper.updateByPrimaryKeySelective(omsshipInstructionsCapacity);
    }

    /**
     * 查询
     * @param instructionsCapacityId
     * @return
     */
    @Override
    public OmsshipInstructionsCapacity selectByPrimaryKey(BigDecimal instructionsCapacityId) {
        return omsshipInstructionsCapacityMapper.selectByPrimaryKey(instructionsCapacityId);
    }

    /**
     * 修改
     * @param omsshipInstructionsCapacity
     * @return
     */
    @Override
    public int updateByPrimaryKeySelective(OmsshipInstructionsCapacity omsshipInstructionsCapacity) {
        omsshipInstructionsCapacity.setUpdateTime(new Date());
        return omsshipInstructionsCapacityMapper.updateByPrimaryKeySelective(omsshipInstructionsCapacity);
    }

    /**
     * 查询一条装船指令下的所有船信息
     * @param mapVal
     * @return
     */
    @Override
    public List<Map<String, Object>> selectCapacities(Map<String, Object> mapVal) {
        return omsshipInstructionsCapacityMapper.selectCapacities(mapVal);
    }

    @Override
    public List<Map<String, Object>> getCapacityId() {
        return omsshipInstructionsCapacityMapper.selectCapacityId();
    }

    /**
     * 查询表单信息
     * @param instructionsCapacityId
     * @return
     */
    @Override
    public List<Map<String, Object>> selectInstructionsCapacity(BigDecimal instructionsCapacityId) {
        return omsshipInstructionsCapacityMapper.selectInstructionsCapacity(instructionsCapacityId);
    }
}
