package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.TmstrainPleaseResultMapper;
import com.steerinfo.dil.model.TmsshipTotalResult;
import com.steerinfo.dil.mapper.TmsshipTotalResultMapper;
import com.steerinfo.dil.model.TmstrainPleaseResult;
import com.steerinfo.dil.service.ITmsshipTotalResultService;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.framework.controller.RESTfulResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;

/**
 * TmsshipTotalResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 08:55
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmsshipTotalResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service
public class TmsshipTotalResultServiceImpl implements ITmsshipTotalResultService {

    @Autowired
    TmsshipTotalResultMapper tmsshipTotalResultMapper;

    @Autowired
    TmstrainPleaseResultMapper tmstrainPleaseResultMapper;

    /**
     * 得到一个总实绩id
     * @param orderId
     * @return
     */
    @Override
    public BigDecimal selectTotalId(BigDecimal orderId) {
        return tmsshipTotalResultMapper.selectResultTotalId(orderId);
    }

    /**
     * 逻辑获取一个总实绩id
     * @param orderId
     * @return
     */
    @Override
    public BigDecimal getResultTotalId(BigDecimal orderId) {
        BigDecimal resultTotalId = selectTotalId(orderId);
        if (resultTotalId == null) {
            TmsshipTotalResult tmsshipTotalResult = new TmsshipTotalResult();
            BigDecimal totalId = tmsshipTotalResultMapper.selectTotalId();
            tmsshipTotalResult.setResultId(totalId);
            tmsshipTotalResult.setOrderId(orderId);
            tmsshipTotalResult.setResultDuration(null);
            tmsshipTotalResult.setStandardDataId(new BigDecimal(1004));
            tmsshipTotalResult.setResultOutlier(null);
            //设置船舶状态为运行中
            tmsshipTotalResult.setShipStatus(new BigDecimal(0) );
            // 插入常规字段
            tmsshipTotalResult.setInsertTime(new Date());
            tmsshipTotalResult.setUpdateTime(new Date());
            tmsshipTotalResult.setInsertUsername("admin");
            tmsshipTotalResult.setUpdateUsername("admin");
            tmsshipTotalResult.setInsertUpdateRemark("无");
            tmsshipTotalResultMapper.insert(tmsshipTotalResult);
        }
        return selectTotalId(orderId);
    }

    /**
     * 展示水路货物运单
     * @param mapVal
     * @return
     */
    @Override
    public List<Map<String, Object>> getOrderList(Map<String,Object> mapVal) {
        List<Map<String,Object>> mapList=new ArrayList<>();
        mapList=tmsshipTotalResultMapper.selectOrderList(mapVal);
        for (Map<String,Object> map:mapList){
            map.put("shipperAbbreviation","四川达州钢铁集团有限责任公司");
        }
        return mapList;
    }

    /**
     * 展示船只信息
     * @param mapVal
     * @return
     */
    @Override
    public List<Map<String, Object>> getCapacity(Map<String, Object> mapVal) {
        return tmsshipTotalResultMapper.getCapacity(mapVal);
    }

    @Override
    public int editPleaseResult(Map<String, Object> mapVal) {
        TmstrainPleaseResult tmstrainPleaseResult=new TmstrainPleaseResult();
        tmstrainPleaseResult.setResultId(DataChange.dataToBigDecimal(mapVal.get("resultId")));
        if(mapVal.get("resultDate")!=null)
            tmstrainPleaseResult.setResultDate(new Date((Long)(mapVal.get("resultDate"))));
        if(mapVal.get("resultApproveNumber")!=null)
            tmstrainPleaseResult.setResultApproveNumber(DataChange.dataToBigDecimal(mapVal.get("resultApproveNumber")));
        if(mapVal.get("resultVoidNumber")!=null)
            tmstrainPleaseResult.setResultVoidNumber(DataChange.dataToBigDecimal(mapVal.get("resultVoidNumber")));
        if(mapVal.get("resultRealNumber")!=null)
            tmstrainPleaseResult.setResultRealNumber(DataChange.dataToBigDecimal(mapVal.get("resultRealNumber")));
        if(mapVal.get("resultSurplusNumber")!=null)
            tmstrainPleaseResult.setResultSurplusNumber(DataChange.dataToBigDecimal(mapVal.get("resultSurplusNumber")));
        if(mapVal.get("userId")!=null)
            tmstrainPleaseResult.setUpdateUsername(mapVal.get("userId").toString());
        if(mapVal.get("deleted")!=null)
            tmstrainPleaseResult.setDeleted(DataChange.dataToBigDecimal(mapVal.get("deleted")));
        tmstrainPleaseResult.setUpdateTime(new Date());
        return tmstrainPleaseResultMapper.updateByPrimaryKeySelective(tmstrainPleaseResult);
    }

    @Override
    public List<Map<String, Object>> getAllPleaseResult(Map<String, Object> mapVal) {
        return tmstrainPleaseResultMapper.getAllPleaseResult(mapVal);
    }

    @Override
    public Map<String, Object> getPleaseResult(BigDecimal resultId) {
        Map<String,Object> map=new HashMap<>();
        map.put("resultId",resultId);
        return tmstrainPleaseResultMapper.getPleaseResult(map);
    }

    @Override
    public int addPleaseResult(Map<String, Object> mapVal) {
        TmstrainPleaseResult tmstrainPleaseResult=new TmstrainPleaseResult();
        tmstrainPleaseResult.setResultId(tmstrainPleaseResultMapper.selectMaxId());
        tmstrainPleaseResult.setResultDate(new Date((Long)(mapVal.get("resultDate"))));
        tmstrainPleaseResult.setResultApproveNumber(DataChange.dataToBigDecimal(mapVal.get("resultApproveNumber")));
        tmstrainPleaseResult.setResultVoidNumber(DataChange.dataToBigDecimal(mapVal.get("resultVoidNumber")));
        tmstrainPleaseResult.setResultRealNumber(DataChange.dataToBigDecimal(mapVal.get("resultRealNumber")));
        tmstrainPleaseResult.setResultSurplusNumber(DataChange.dataToBigDecimal(mapVal.get("resultSurplusNumber")));
        tmstrainPleaseResult.setInsertTime(new Date());
        tmstrainPleaseResult.setInsertUsername(mapVal.get("userId").toString());
        tmstrainPleaseResult.setDeleted(new BigDecimal(0));
        return tmstrainPleaseResultMapper.insert(tmstrainPleaseResult);
    }

    @Override
    public BigDecimal getRealNumber(Map<String,Object> map) {
        return tmstrainPleaseResultMapper.getRealNumber(map);
    }
}
